
import ch.aplu.nxt.NxtRobot;
import ch.aplu.nxt.SensorPort;
import ch.aplu.nxt.SuperProSensor;
import ch.aplu.nxt.Tools;
import lejos.nxt.Button;
import lejos.nxt.LCD;

/**
 * Aangepaste versie van Experiment 4.
 * Meet licht met lichtsensor aan ain1 en
 * laat gemeten hoeveelheid licht zien dmv led-niveau indicator gemaakt met zes LEDS op dout uitgangen (b0-b5), zoals bij Experiment 3.
 * 
 * @author Fjodor van Slooten
 *
 */
public class SuperProExp4b
{
  private final int out = 1;

  public SuperProExp4b()
  {
    NxtRobot robot = new NxtRobot();
    SuperProSensor sps = new SuperProSensor(SensorPort.S1);
    robot.addPart(sps);
    int dout;
    int[] ain = new int[4];
    int[] ioControl = {out, out, out, out, out, out, out, out};
    sps.setDIO(ioControl);
    int lightlevel;

    while (!Button.ESCAPE.isDown())
    {
      sps.readAnalog(ain);
      lightlevel = ain[1];
      LCD.clear();
      LCD.drawInt(lightlevel, 0, 0);
      dout = 0x00;
      if (lightlevel > 175)
    	  dout += 0x01;
      if (lightlevel > 250)
    	  dout += 0x02;
      if (lightlevel > 350)
    	  dout += 0x04;
      if (lightlevel > 450)
    	  dout += 0x08;
      if (lightlevel > 600)
    	  dout += 0x10;
      if (lightlevel > 700)
    	  dout += 0x20;
      sps.write(dout);
      Tools.delay(50);
    }
  }

  public static void main(String[] args)
  {
    new SuperProExp4b();
  }
}
