// SuperProExp6.java

/*   HiTechnic Experimenter's Kit Program

Experiment - 6 Reaction Time Measurement

This program measures the time taken to press a button switch after a LED is
turned on.

(c) HiTechnic 2009

*/

// Adapted to Java by Aegidius Pluess (www.aplu.ch)

import ch.aplu.nxt.*;
import lejos.nxt.Button;
import lejos.nxt.LCD;

public class SuperProExp6
{
  private final int in = 0;
  private final int out = 1;

  public SuperProExp6()
  {
    NxtRobot robot = new NxtRobot();
    SuperProSensor sps = new SuperProSensor(SensorPort.S1);
    robot.addPart(sps);
    int[] din = new int[8];
    int[] dout = new int[8];
    int[] ioControl = { out, out, out, out, in, in, in, in };
    sps.setDIO(ioControl);

    
    
    /*
     * Rest van code om Experiment 6 uit te voeren:
     */
    int randomtime;
    while (!Button.ENTER.isDown())
    {
      sps.write(0);
      LCD.clear();
      LCD.drawString("running", 0, 0);
      randomtime = (int)(5000 * Math.random()) + 5000;
      Tools.delay(randomtime);
      sps.write(0x01);
      Tools.startTimer();
      do
      {
        sps.readDigital(din);
      }
      while (din[4] == 0);
      sps.write(0);
      LCD.clear();
      LCD.drawInt((int)Tools.getTime(), 0, 0);
      // wacht tot 1 van de schakelaars op poort b4 of b5 wordt ingedrukt:
      do
      {
          sps.readDigital(din);
      }
      while (din[4] == 0 || din[5] == 0);
    }
  }

  public static void main(String[] args)
  {
    new SuperProExp6();
  }
}
