// SuperProExp6Var.java

/*   HiTechnic Experimenter's Kit Program

Experiment - 6 Reaction Time Measurement

This program measures the time taken to press a button switch after a LED is
turned on.

(c) HiTechnic 2009

*/

// Adapted to Java by Aegidius Pluess (www.aplu.ch)

import ch.aplu.nxt.*;
import lejos.nxt.LCD;

public class SuperProExp6Var
{
  private final int in = 0;
  private final int out = 1;

  public SuperProExp6Var()
  {
    NxtRobot robot = new NxtRobot();
    SuperProSensor sps = new SuperProSensor(SensorPort.S1);
    robot.addPart(sps);
    int[] din = new int[8];
    int[] ioControl = {out, out, out, out, in, in, out, out};
    sps.setDIO(ioControl);

    int randomtime;
    int buttonindex;
    int outputmask;
    while (true)
    {
      sps.write(0);
      LCD.clear();
      LCD.drawString("running", 0, 0);
      if (Math.random() < 0.5)
      {
        outputmask = 0x01;
        buttonindex = 4;
      }
      else
      {
        outputmask = 0x02;
        buttonindex = 5;
      }
      randomtime = (int)(5000 * Math.random()) + 5000;
      Tools.delay(randomtime);
      sps.write(outputmask);
      Tools.startTimer();
      do
      {
        sps.readDigital(din);
      }
      while (din[buttonindex] == 0);
      sps.write(0);
      LCD.clear();
      LCD.drawInt((int)Tools.getTime(), 0, 0);
      do
      {
          sps.readDigital(din);
      }
      while (din[4] == 0 || din[5] == 0);
    }
  }

  public static void main(String[] args)
  {
    new SuperProExp6Var();
  }
}
