// SuperProExp7.java

/*   HiTechnic Experimenter's Kit Program

Experiment - 7 Magnetic Switch Sensor

This program measures reads the status of the magnetic sensor and outputs the
status.

(c) HiTechnic 2009

*/


// Adapted to Java by Aegidius Pluess (www.aplu.ch)

import ch.aplu.nxt.*;
import lejos.nxt.LCD;

public class SuperProExp7
{
  private final int in = 0;
  private final int out = 1;

  public SuperProExp7()
  {
    NxtRobot robot = new NxtRobot();
    SuperProSensor sps = new SuperProSensor(SensorPort.S1);
    robot.addPart(sps);
    int[] din = new int[8];
    int[] ioControl = {in, out, out, out, out, out, out, out};
    sps.setDIO(ioControl);
    while (true)
    {
      LCD.clear();
      sps.readDigital(din);
      if (din[0] == 0)
      {
        LCD.drawString("Magnet present", 0, 0);
        sps.write(0x10);
      }
      else
      {
        LCD.drawString("Magnet absent", 0, 0);
        sps.write(0);
      }
      Tools.delay(50);
    }
  }

  public static void main(String[] args)
  {
    new SuperProExp7();
  }
}
